/*
 * Generated by Digital. Don't modify this file!
 * Any changes will be lost if this file is regenerated.
 */
module DIG_JK_FF
#(
    parameter Default = 1'b0
)
(
   input J,
   input C,
   input K,
   output Q,
   output \~Q
);
    reg state;

    assign Q = state;
    assign \~Q = ~state;

    always @ (posedge C) begin
        if (~J & K)
            state <= 1'b0;
         else if (J & ~K)
            state <= 1'b1;
         else if (J & K)
            state <= ~state;
    end

    initial begin
        state = Default;
    end
endmodule


module Demux2
(
    output out_0,
    output out_1,
    output out_2,
    output out_3,
    input [1:0] sel,
    input in
);
    assign out_0 = (sel == 2'h0)? in : 'd0;
    assign out_1 = (sel == 2'h1)? in : 'd0;
    assign out_2 = (sel == 2'h2)? in : 'd0;
    assign out_3 = (sel == 2'h3)? in : 'd0;
endmodule


module DIG_Register_BUS #(
    parameter Bits = 1
)
(
    input C,
    input en,
    input [(Bits - 1):0]D,
    output [(Bits - 1):0]Q
);

    reg [(Bits - 1):0] state = 'h0;

    assign Q = state;

    always @ (posedge C) begin
        if (en)
            state <= D;
   end
endmodule

module DIG_Counter_Nbit
#(
    parameter Bits = 2
)
(
    output [(Bits-1):0] out,
    output ovf,
    input C,
    input en,
    input clr
);
    reg [(Bits-1):0] count;

    always @ (posedge C) begin
        if (clr)
          count <= 'h0;
        else if (en)
          count <= count + 1'b1;
    end

    assign out = count;
    assign ovf = en? &count : 1'b0;

    initial begin
        count = 'h0;
    end
endmodule


module VGA_CMP10 (
  input [9:0] A, // Input A
  input [9:0] B, // Input B
  output Q // Equal

);
  assign Q = (~ (A[0] ^ B[0]) & ~ (A[1] ^ B[1]) & ~ (A[2] ^ B[2]) & ~ (A[3] ^ B[3]) & ~ (A[4] ^ B[4]) & ~ (A[5] ^ B[5]) & ~ (A[6] ^ B[6]) & ~ (A[7] ^ B[7]) & ~ (A[8] ^ B[8]) & ~ (A[9] ^ B[9]));
endmodule

module CompUnsigned #(
    parameter Bits = 1
)
(
    input [(Bits -1):0] a,
    input [(Bits -1):0] b,
    output \> ,
    output \= ,
    output \<
);
    assign \> = a > b;
    assign \= = a == b;
    assign \< = a < b;
endmodule


module CPLD_SYNC (
  input C25,
  input EN, // Enable Display
  input nC25,
  output [8:0] PX, // Pixel X Counter
                   // 
                   // 0 - 319
  output [7:0] PY, // Pixel Y Counter
                   // 
                   // 0 - 249
  output EO, // Enable Output
  output \~HS , // Horizontal Sync
  output \~VS , // Vertical Sync
  output IRQ_S, // IRQ Output
  output RDD, // Read Data from VRAM
  output RDC, // Read Color from VRAM
  output RDI, // Read ID from VRAM
  output Y0 // Pixel Y Counter bit 0

);
  wire s0;
  wire [9:0] s1;
  wire s2;
  wire [9:0] s3;
  wire [8:0] PX_temp;
  wire EO_temp;
  wire s4;
  wire s5;
  wire s6;
  wire s7;
  wire s8;
  wire s9;
  wire s10;
  wire s11;
  wire s12;
  wire s13;
  wire s14;
  wire s15;
  assign RDI = (EO_temp & EN & s9 & ~ s10 & s11);
  assign RDC = (EO_temp & EN & ~ s9 & s10 & s11);
  assign RDD = (EO_temp & EN & s9 & s10 & s11);
  // X-CNT
  DIG_Counter_Nbit #(
    .Bits(10)
  )
  DIG_Counter_Nbit_i0 (
    .en( 1'b1 ),
    .C( C25 ),
    .clr( s0 ),
    .out( s1 )
  );
  // Y-CNT
  DIG_Counter_Nbit #(
    .Bits(10)
  )
  DIG_Counter_Nbit_i1 (
    .en( s0 ),
    .C( C25 ),
    .clr( s2 ),
    .out( s3 )
  );
  // HS
  DIG_JK_FF #(
    .Default(0)
  )
  DIG_JK_FF_i2 (
    .J( s4 ),
    .C( nC25 ),
    .K( s5 ),
    .\~Q ( \~HS  )
  );
  // VS
  DIG_JK_FF #(
    .Default(0)
  )
  DIG_JK_FF_i3 (
    .J( s6 ),
    .C( nC25 ),
    .K( s7 ),
    .\~Q ( \~VS  )
  );
  assign s2 = (s0 & s8);
  VGA_CMP10 VGA_CMP10_i4 (
    .A( s1 ),
    .B( 10'b1010001111 ),
    .Q( s4 )
  );
  VGA_CMP10 VGA_CMP10_i5 (
    .A( s1 ),
    .B( 10'b1011101111 ),
    .Q( s5 )
  );
  VGA_CMP10 VGA_CMP10_i6 (
    .A( s1 ),
    .B( 10'b1100011111 ),
    .Q( s0 )
  );
  VGA_CMP10 VGA_CMP10_i7 (
    .A( s3 ),
    .B( 10'b111101001 ),
    .Q( s6 )
  );
  VGA_CMP10 VGA_CMP10_i8 (
    .A( s3 ),
    .B( 10'b111101011 ),
    .Q( s7 )
  );
  VGA_CMP10 VGA_CMP10_i9 (
    .A( s3 ),
    .B( 10'b1000001100 ),
    .Q( s8 )
  );
  CompUnsigned #(
    .Bits(10)
  )
  CompUnsigned_i10 (
    .a( s3 ),
    .b( 10'b111011111 ),
    .\> ( s12 ),
    .\= ( s13 )
  );
  CompUnsigned #(
    .Bits(10)
  )
  CompUnsigned_i11 (
    .a( s1 ),
    .b( 10'b1001111111 ),
    .\> ( s14 ),
    .\= ( s15 )
  );
  assign EO_temp = (~ s14 & ~ s12);
  assign IRQ_S = (s15 & s13);
  assign PX_temp = s1[9:1];
  assign Y0 = s3[0];
  assign PY = s3[8:1];
  assign s9 = PX_temp[0];
  assign s10 = PX_temp[1];
  assign s11 = PX_temp[2];
  assign PX = PX_temp;
  assign EO = EO_temp;
endmodule
module DIG_D_FF_1bit
#(
    parameter Default = 0
)
(
   input D,
   input C,
   output Q,
   output \~Q
);
    reg state;

    assign Q = state;
    assign \~Q = ~state;

    always @ (posedge C) begin
        state <= D;
    end

    initial begin
        state = Default;
    end
endmodule


module Mux_8x1
(
    input [2:0] sel,
    input in_0,
    input in_1,
    input in_2,
    input in_3,
    input in_4,
    input in_5,
    input in_6,
    input in_7,
    output reg out
);
    always @ (*) begin
        case (sel)
            3'h0: out = in_0;
            3'h1: out = in_1;
            3'h2: out = in_2;
            3'h3: out = in_3;
            3'h4: out = in_4;
            3'h5: out = in_5;
            3'h6: out = in_6;
            3'h7: out = in_7;
            default:
                out = 'h0;
        endcase
    end
endmodule

module DIG_Add
#(
    parameter Bits = 1
)
(
    input [(Bits-1):0] a,
    input [(Bits-1):0] b,
    input c_i,
    output [(Bits - 1):0] s,
    output c_o
);
   wire [Bits:0] temp;

   assign temp = a + b + c_i;
   assign s = temp [(Bits-1):0];
   assign c_o = temp[Bits];
endmodule



module Mux_2x1_NBits #(
    parameter Bits = 2
)
(
    input [0:0] sel,
    input [(Bits - 1):0] in_0,
    input [(Bits - 1):0] in_1,
    output reg [(Bits - 1):0] out
);
    always @ (*) begin
        case (sel)
            1'h0: out = in_0;
            1'h1: out = in_1;
            default:
                out = 'h0;
        endcase
    end
endmodule


module \CPLD-MAIN  (
  input C_I,
  input nRES_I, // Reset
  input nRE_I, // Register Enable
  input [7:0] VRAM_DATA, // VRAM Data input
  input [7:0] CPU_DATA, // CPU Data Input
  input CPU_CLK, // CPU Clock Input
  input CPU_RnW, // CPU Read/Write Input
  input [1:0] CPU_A, // CPU Address Input
  input CPU_RE, // CPU Register Enable
  output [1:0] R_O, // Red
  output [1:0] G_O, // Green
  output [1:0] B_O, // Blue
  output HS_O, // H Sync
  output VS_O, // V Sync
  output [12:0] ADDR_O, // Address output
  output nCS_O, // Memory CS Output
  output nOE_O, // VRAM Read
  output nWE_O, // VRAM Write
  output nIRQ_O // Interrupt Output

);
  wire [7:0] s0;
  wire [7:0] s1;
  wire s2;
  wire [3:0] s3;
  wire [3:0] s4;
  wire [3:0] s5;
  wire [2:0] PXS;
  wire s6;
  wire s7;
  wire s8;
  wire s9;
  wire s10;
  wire s11;
  wire s12;
  wire s13;
  wire \~C25 ;
  wire DOE;
  wire [3:0] s14;
  wire C12;
  wire \~C12 ;
  wire [7:0] s15;
  wire \LD-D ;
  wire [7:0] s16;
  wire \LD-T ;
  wire [7:0] TILE;
  wire \LD-C ;
  wire s17;
  wire s18;
  wire s19;
  wire s20;
  wire s21;
  wire R;
  wire [7:0] s22;
  wire [2:0] PYS;
  wire [4:0] TYS;
  wire [10:0] s23;
  wire [10:0] s24;
  wire [10:0] s25;
  wire [10:0] s26;
  wire [10:0] s27;
  wire s28;
  wire [10:0] s29;
  wire [5:0] s30;
  wire [10:0] s31;
  wire s32;
  wire [10:0] s33;
  wire [2:0] s34;
  wire \R-D ;
  wire [10:0] s35;
  wire [10:0] AD;
  wire s36;
  wire [5:0] TXS;
  wire s37;
  wire s38;
  wire \R-C ;
  wire [8:0] s39;
  wire EN_DIS;
  wire IRQ;
  wire s40;
  wire Y0;
  wire [1:0] s41;
  wire nCC;
  wire s42;
  wire [1:0] s43;
  wire s44;
  wire s45;
  wire [1:0] s46;
  wire s47;
  wire s48;
  wire s49;
  wire s50;
  wire s51;
  assign nWE_O = 1'b1;
  assign nCS_O = 1'b0;
  assign \~C25  = ~ C_I;
  DIG_JK_FF #(
    .Default(0)
  )
  DIG_JK_FF_i0 (
    .J( 1'b1 ),
    .C( C_I ),
    .K( 1'b1 ),
    .Q( C12 ),
    .\~Q ( \~C12  )
  );
  assign R = ~ nRES_I;
  assign nCC = ~ CPU_CLK;
  assign s44 = (~ CPU_RnW & ~ CPU_RE);
  assign s41 = CPU_DATA[7:6];
  Demux2 Demux2_i1 (
    .sel( CPU_A ),
    .in( s44 ),
    .out_0( s42 )
  );
  // CTL0_C
  DIG_Register_BUS #(
    .Bits(2)
  )
  DIG_Register_BUS_i2 (
    .D( s41 ),
    .C( nCC ),
    .en( s42 ),
    .Q( s43 )
  );
  assign s45 = ~ s42;
  // TILE_R
  DIG_Register_BUS #(
    .Bits(8)
  )
  DIG_Register_BUS_i3 (
    .D( VRAM_DATA ),
    .C( \~C25  ),
    .en( \LD-T  ),
    .Q( TILE )
  );
  // COLR0_R
  DIG_Register_BUS #(
    .Bits(8)
  )
  DIG_Register_BUS_i4 (
    .D( VRAM_DATA ),
    .C( \~C25  ),
    .en( \LD-C  ),
    .Q( s15 )
  );
  CPLD_SYNC CPLD_SYNC_i5 (
    .C25( C_I ),
    .EN( EN_DIS ),
    .nC25( \~C25  ),
    .PX( s39 ),
    .PY( s22 ),
    .EO( DOE ),
    .\~HS ( HS_O ),
    .\~VS ( VS_O ),
    .IRQ_S( IRQ ),
    .RDD( \R-D  ),
    .RDC( \R-C  ),
    .RDI( s40 ),
    .Y0( Y0 )
  );
  // CTL0_I
  DIG_Register_BUS #(
    .Bits(2)
  )
  DIG_Register_BUS_i6 (
    .D( s43 ),
    .C( IRQ ),
    .en( s45 ),
    .Q( s46 )
  );
  DIG_D_FF_1bit #(
    .Default(0)
  )
  DIG_D_FF_1bit_i7 (
    .D( s48 ),
    .C( nCC ),
    .Q( s49 )
  );
  DIG_D_FF_1bit #(
    .Default(0)
  )
  DIG_D_FF_1bit_i8 (
    .D( s49 ),
    .C( nCC ),
    .Q( s47 )
  );
  assign \LD-D  = (\R-D  & DOE & C12);
  assign \LD-C  = (\R-C  & DOE & C12);
  assign \LD-T  = (s40 & DOE & C12);
  // DAT0_R
  DIG_Register_BUS #(
    .Bits(8)
  )
  DIG_Register_BUS_i9 (
    .D( VRAM_DATA ),
    .C( \~C25  ),
    .en( \LD-D  ),
    .Q( s0 )
  );
  // DAT1_R
  DIG_Register_BUS #(
    .Bits(8)
  )
  DIG_Register_BUS_i10 (
    .D( s0 ),
    .C( C_I ),
    .en( 1'b1 ),
    .Q( s1 )
  );
  // COLR1_R
  DIG_Register_BUS #(
    .Bits(8)
  )
  DIG_Register_BUS_i11 (
    .D( s15 ),
    .C( C_I ),
    .en( \LD-D  ),
    .Q( s16 )
  );
  assign s23[2:0] = 3'b0;
  assign s23[10:3] = TILE;
  assign nOE_O = ~ (\R-D  | \R-C  | s40);
  assign nIRQ_O = ~ (s46[0] & (s49 | s47));
  DIG_JK_FF #(
    .Default(0)
  )
  DIG_JK_FF_i12 (
    .J( IRQ ),
    .C( C_I ),
    .K( s47 ),
    .Q( s48 )
  );
  assign PYS = s22[2:0];
  assign TYS = s22[7:3];
  assign PXS = s39[2:0];
  assign TXS = s39[8:3];
  assign EN_DIS = s46[1];
  assign s24[2:0] = 3'b0;
  assign s24[7:3] = TYS;
  assign s24[10:8] = 3'b0;
  CompUnsigned #(
    .Bits(6)
  )
  CompUnsigned_i13 (
    .a( TXS ),
    .b( 6'b100111 ),
    .\= ( s37 )
  );
  assign s25[4:0] = 5'b0;
  assign s25[9:5] = TYS;
  assign s25[10] = 1'b0;
  assign s51 = (PYS[0] & PYS[1] & PYS[2] & Y0);
  assign s13 = s1[0];
  assign s12 = s1[1];
  assign s11 = s1[2];
  assign s10 = s1[3];
  assign s9 = s1[4];
  assign s8 = s1[5];
  assign s7 = s1[6];
  assign s6 = s1[7];
  assign s3 = s16[3:0];
  assign s4 = s16[7:4];
  Mux_8x1 Mux_8x1_i14 (
    .sel( PXS ),
    .in_0( s6 ),
    .in_1( s7 ),
    .in_2( s8 ),
    .in_3( s9 ),
    .in_4( s10 ),
    .in_5( s11 ),
    .in_6( s12 ),
    .in_7( s13 ),
    .out( s2 )
  );
  DIG_Add #(
    .Bits(11)
  )
  DIG_Add_i15 (
    .a( s25 ),
    .b( s24 ),
    .c_i( 1'b0 ),
    .s( s26 )
  );
  assign s38 = (~ s51 & s37);
  assign s50 = (s37 & s51);
  Mux_2x1_NBits #(
    .Bits(4)
  )
  Mux_2x1_NBits_i16 (
    .sel( s2 ),
    .in_0( s3 ),
    .in_1( s4 ),
    .out( s5 )
  );
  Mux_2x1_NBits #(
    .Bits(6)
  )
  Mux_2x1_NBits_i17 (
    .sel( s38 ),
    .in_0( TXS ),
    .in_1( 6'b0 ),
    .out( s30 )
  );
  assign s28 = ~ s38;
  assign s32 = ((s38 & ~ (PYS[0] & PYS[1] & PYS[2])) & Y0);
  Mux_2x1_NBits #(
    .Bits(3)
  )
  Mux_2x1_NBits_i18 (
    .sel( s50 ),
    .in_0( PYS ),
    .in_1( 3'b0 ),
    .out( s34 )
  );
  Mux_2x1_NBits #(
    .Bits(4)
  )
  Mux_2x1_NBits_i19 (
    .sel( DOE ),
    .in_0( 4'b0 ),
    .in_1( s5 ),
    .out( s14 )
  );
  assign s27[5:0] = s30;
  assign s27[10:6] = 5'b0;
  assign s31[2:0] = s34;
  assign s31[10:3] = 8'b0;
  DIG_Add #(
    .Bits(11)
  )
  DIG_Add_i20 (
    .a( s27 ),
    .b( s26 ),
    .c_i( s28 ),
    .s( s29 )
  );
  DIG_Add #(
    .Bits(11)
  )
  DIG_Add_i21 (
    .a( s31 ),
    .b( s23 ),
    .c_i( s32 ),
    .s( s33 )
  );
  assign s17 = s14[0];
  assign s18 = s14[1];
  assign s19 = s14[2];
  assign s20 = s14[3];
  assign s21 = ~ (s17 | s18 | s19);
  CompUnsigned #(
    .Bits(11)
  )
  CompUnsigned_i22 (
    .a( s29 ),
    .b( 11'b10010101111 ),
    .\> ( s36 )
  );
  assign R_O[0] = s17;
  assign R_O[1] = ((s17 | s21) & s20);
  assign G_O[0] = s18;
  assign G_O[1] = ((s18 | s21) & s20);
  assign B_O[0] = s19;
  assign B_O[1] = ((s19 | s21) & s20);
  Mux_2x1_NBits #(
    .Bits(11)
  )
  Mux_2x1_NBits_i23 (
    .sel( s36 ),
    .in_0( s29 ),
    .in_1( 11'b0 ),
    .out( s35 )
  );
  Mux_2x1_NBits #(
    .Bits(11)
  )
  Mux_2x1_NBits_i24 (
    .sel( \R-D  ),
    .in_0( s35 ),
    .in_1( s33 ),
    .out( AD )
  );
  assign ADDR_O[10:0] = AD;
  assign ADDR_O[11] = \R-C ;
  assign ADDR_O[12] = \R-D ;
endmodule
